read "KY.mpl";
read "TestQuestions.mpl";

test1 := true;
test2 := true;
test3 := true;

if test1 = true then

   totalTime1 := [seq(time()-time(),i=1..11)];
   evalTime1 := [seq(time()-time(),i=1..11)];

   for i from 2 to 11 do

  uniDegTime, totDegTime, checkTime, gcdPTime,  chremTime, evalTime, RatreconTime, lambdaTime, BenOrTime := time() - time(), time() - time(), time() - time(), time() - time(), time() - time(), time() - time(), time() - time(), time() - time(), time() - time();

   n := 2*i;
   X := [x||(1..n)]; Y := [y||(1..n)]; Z := [op(X),op(Y)];
   X2 := [X[1],X[2],op(Y[3..n])];

   probeCount := 0;

   b1 := bbVanCFast1(n);
   b2 := bbVanCFast2(n);

    st := time():
    g := BBMGCD(b1,b2,Z);
    totalTime1[i-1] :=  time() - st;
    evalTime1[i-1] := probeCount;
    print(factor(g));

    printTimings();

   od;
fi;

print(totalTime1);
print(evalTime1);

#test set 2
if test2 = true then
   n := 5;
   X := [x||(1..n)];
   #s := [10,100,1000,2500,5000,10000]; t := [10000,5000,2500,1000,100,10];
   s := [10, 100 ,250, 500 ,1000]; t := [1000, 500, 250, 100, 10];

   totalTime2 := [seq(time()-time(),i=1..5)];
   evalTime2 := [seq(time()-time(),i=1..5)];

   for i from 1 to nops(s) do

   uniDegTime, totDegTime, checkTime, gcdPTime,  chremTime, evalTime, RatreconTime, lambdaTime, BenOrTime := time() - time(), time() - time(), time() - time(), time() - time(), time() - time(),time() - time(), time() - time(), time() - time(), time() - time();

      dd := 10;

      g := randpoly(X,terms=s[i],degree=dd):
      abar := randpoly(X,terms=t[i],degree=dd):
      bbar := randpoly(X,terms=t[i],degree=dd):

     probeCount := 0;

      ba := bbpolygen(abar,g,X): bb := bbpolygen(bbar,g,X):


      st := time():
      g2 := BBMGCD(ba,bb,X):
      totalTime2[i] :=  time() - st;
      evalTime2[i] := probeCount;

       print(g);
       print(g2);

       gTrue := expand(g*gcd(abar,bbar)):
       g2 := expand(g2):
       if gTrue = g2 or gTrue = -g2 then
          print("pass");
       else
          print("fail");
       fi;
   od:

   printTimings();

fi;

#print(totalTime2);
#print(evalTime2);


#test set 3
if test3 = true then
   n := 5; m := 10;
   X := [x||(1..n)];

   totalTime3 := [seq(time()-time(),i=1..m)];
   evalTime3 := [seq(time()-time(),i=1..m)];

   for i from 1 to m do

      uniDegTime, totDegTime, checkTime, gcdPTime,  chremTime, evalTime, RatreconTime, lambdaTime, BenOrTime := time() - time(), time() - time(), time() - time(), time() - time(), time() - time(),time() - time(), time() - time(), time() - time(), time() - time();

      a := expand(g*abar): b := expand(g*bbar):

      b1 :=  bbGarrettTest1(n,i,1):
      b2 :=  bbGarrettTest1(n,i,2):

      probeCount := 0;

      st := time():
      g2 := BBMGCD(b1,b2,X):
      if g2 = FAIL then totalTime4[i] := FAIL; else
      totalTime3[i] :=  time() - st; fi;
      evalTime3[i] := probeCount;

        #printf("right here\n");

      printTimings();

      print(factor(g2));

       #gTrue := expand(g*gcd(abar,bbar));
       #g2 := expand(g2);
      # if gTrue = g2 or gTrue = -g2 then
      #    print("pass");
      # else
       #   print("fail");
       #fi;
   od:

fi;


#print(totalTime1);
#print(evalTime1);
#print(totalTime2);
#print(evalTime2);
#print(totalTime3);
#print(evalTime3);


